#!/usr/bin/env python
# -*- coding: utf-8 -*-

from models.event import Event
from models.user import User
from models.conversation import Conversation
from flask_app import api, app
from flask_restplus import Resource, fields
from flask_restplus.errors import abort
from flask import request
from util.alchemy import db, engine
from sqlalchemy.orm import sessionmaker


nm_event = api.namespace(
    "event", description="A event originated from a source monitored by MsFLOSS")

event_api_model = api.model('Event', {
    'id': fields.Integer(readonly=True,description="The message id",example=32),
    'conversation': fields.String(readonly=True,description='The id of the related conversation',example="c321233c-a674-4ab7-8b25-8047a8235ce7"),
    'user': fields.String(required=True,description="The user who send the message",example="Some User <email@sever.com>"),
    'timestamp': fields.DateTime(description="The timestamp of the messsage. If not provided the current datetime will be used as a timestamp.", example="2019-06-02T12:32:34"),
    'type': fields.String(enum=['MSG', 'LIN', 'LOUT'],required=True,description="A message type",example="MSG"),
    'content': fields.String(required=True,description="The message content", example="Some really cool message.\nThe message has a lot of content.\n\nAnd that's fine!"),
})

event_api_model_list = api.model('Event List', {
    'events': fields.List(fields.Nested(event_api_model))
})


@nm_event.route('/')
class EventControllersSimple(Resource):
    @nm_event.marshal_with(event_api_model_list,code=200)
    def get(self):
        query = db.session.query(Event).order_by('timestamp')
        return {"events": list(map(lambda x: x.to_dict(), query.all()))}, 200


@nm_event.route('/<string:conversation_id>')
class EventControllersWithConversationId(Resource):
    @nm_event.expect(event_api_model, validate=True)
    @nm_event.marshal_with(api.model('Event ID',{'id': fields.Integer(description='The Event ID generated by the internal database',example=32)}),code=201)
    def post(self,conversation_id=None):  # Handles route /event
        Session = sessionmaker(bind=engine)

        # Retrieve request data
        request_json = request.get_json()

        # Insert Event
        event = Event(
            conversation = conversation_id,
            user = request_json.get("user"),
            timestamp = request_json.get("timestamp",None),
            type = request_json.get("type"),
            content = request_json.get("content")
        )

        session = Session()
        session.add(event)
        session.commit()

        # Build response
        return_json = {
            "id": event.id,
        }

        return return_json, 201

    @nm_event.marshal_with(event_api_model_list,code=200)
    def get(self, conversation_id=None):
        query = db.session.query(Event).filter_by(conversation=conversation_id).order_by('timestamp')
        return {"events": list(map(lambda x: x.to_dict(), query.all()))}, 200


@nm_event.route('/<string:conversation_id>/<string:event_id>')
class EventControllersWithConversationIdAndEventId(Resource):
    @nm_event.marshal_with(event_api_model,code=200)
    def get(self, conversation_id=None, event_id=None):
        query = db.session.query(Event).filter_by(conversation=conversation_id).filter_by(id=event_id)
        return query.first().to_dict(), 200
